/* This file is part of the KDE project

   Copyright (C) 2004 Dario Massarin <nekkar@libero.it>
   Copyright (C) 2006 Manolo Valdes <nolis71cu@gmail.com>

   This program is free software; you can redistribute it and/or
   modify it under the terms of the GNU General Public
   License as published by the Free Software Foundation; version 2
   of the License.
*/

#ifndef _MultiThreaded_FACTORY_H
#define _MultiThreaded_FACTORY_H

#include <qstring.h>
#include <kurl.h>

#include "core/plugin/transferfactory.h"

class Transfer;
class TransferGroup;
class Scheduler;

class TransferMultiThreadedFactory : public TransferFactory
{
    public:
        TransferMultiThreadedFactory();
        ~TransferMultiThreadedFactory();

        Transfer * createTransfer( KURL srcURL, KURL destURL,
                                   TransferGroup * parent, Scheduler * scheduler,
                                   const QDomElement * e = 0 );

        TransferHandler * createTransferHandler(Transfer * transfer,
                                                Scheduler * scheduler);

        QWidget * createDetailsWidget( TransferHandler * transfer );

        const QList<KAction *> actions();
};

#endif // MultiThreaded_FACTORY_H
